<template>
  <div>
    <div class="tway-header-1 mb-6" style="font-weight: 400">
      Hola {{ user.firstName }}, te damos la bienvenida a la plataforma que te
      guiará por el camino de la Transformación Digital
    </div>
    <v-row no-gutters class="mb-5">
      <v-col
        v-if="
          percentForm == 100 &&
          subscription.plan &&
          subscription.plan.name === 'FREE'
        "
        :class="desktop ? 'px-3' : 'mb-4'"
      >
        <imtd-caption />
      </v-col>
    </v-row>
    <v-row class="ma-0 mb-6" no-gutters>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-img
                  :src="require(`@/assets/img/home/card1.svg`)"
                  contain
                  max-height="630"
                />
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0 px-2" justify="start">
                <div class="full-width">
                  <span class="text-card">
                    Estás en el Plan
                    {{
                      subscription.plan.name.charAt(0).toUpperCase() +
                      subscription.plan.name.slice(1).toLowerCase()
                    }}.<br />
                  </span>
                  <span class="text-card">
                    Descubre todos nuestros planes.
                  </span>
                </div>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :to="{ name: 'plans' }"
                >
                  Ver detalle
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-progress-circular
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentCompany"
                  color="#16C62E"
                >
                  {{ percentCompany }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card"
                  >Completa tu perfil y avanza en tu camino hacia la
                  Transformación Digital.</span
                >
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentCompany >= 100"
                  :to="{ name: 'my-profile' }"
                >
                  <span v-if="percentCompany < 100">Completar mi perfil</span>
                  <span v-else>Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-progress-circular
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentForm"
                  color="#7319D5"
                >
                  {{ percentForm }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card">
                  Completa nuestra encuesta y conoce tu Índice de Madurez en
                  Transformación Digital.
                </span>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentForm == 100"
                  :to="{ name: 'dti-form' }"
                >
                  <span v-if="percentForm != 100">Completar encuesta</span>
                  <span v-if="percentForm == 100">Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="ma-0 mb-6" no-gutters>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-img
                  v-if="percentForm1 == 0"
                  :src="require(`@/assets/img/imo/undraw_imo.png`)"
                  contain
                  max-height="630"
                />
                <v-progress-circular
                  v-if="percentForm1 > 0"
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentForm1"
                  color="#E30513"
                >
                  {{ percentForm1 }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card">
                  ¿Quieres conocer el Índice de Madurez Organizacional de tu
                  empresa?
                </span>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentForm1 == 100"
                  :to="{ name: 'survey-imo' }"
                >
                  <span v-if="percentForm1 != 0 && percentageimo != 100"
                    >Completar encuesta</span
                  >
                  <span v-if="percentForm1 == 0">Realizar encuesta</span>
                  <span v-if="percentForm1 == 100">Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <div class="tway-header-2">Conoce lo último en Transformación</div>
    <trends />
  </div>
</template>

<script>
import HomeTrends from "@/components/specialists/elements/HomeTrends.vue";
import CompanyService from "@/services/companyService";
import CurrentUserService from "@/services/currentUserService";
import SubscriptionService from "@/services/subscriptionService";
import ImtdCaption from "@/components/ImtdCaption.vue";

export default {
  name: "SpecialistHome",

  components: {
    trends: HomeTrends,
    ImtdCaption,
  },
  props: {
    percentage: {
      type: Number,
      default: 0,
      required: false,
    },
    percentageimo: {
      type: Number,
      default: 0,
      required: false,
    },
  },
  data() {
    return {
      loading: false,
      tab: null,
      dimensions: [],
      dti: false,
      company: null,
      percentCompany: 0,
      percentForm: this.percentage,
      percentForm1: this.percentageimo,
      user: {
        name: "",
      },
      subscription: {
        plan: {
          name: "",
        },
      },
    };
  },

  created() {
    this.getCompanyProfile();
    this.getCurrenUserData();
    this.getCurrentUserSubscription();
  },

  methods: {
    getCompanyProfile() {
      CompanyService.getCompanyProfile().then((company) => {
        this.company = company;
        let array = Object.entries(this.company);
        let total = 6;
        let nullables = 0;
        for (let index = 0; index < array.length; index++) {
          const key = array[index][0];
          const val = array[index][1];
          if (key == "dimensions" && val.length == 0) {
            nullables++;
          }

          if (
            (key == "trayectory" ||
              key == "contributionValue" ||
              key == "web" ||
              key == "linkedIn") &&
            !val
          ) {
            nullables++;
          }

          if (key == "size" && (!val || (val && !val.id))) {
            nullables++;
          }
        }
        this.percentCompany = Math.floor(((total - nullables) / total) * 100);
      });
    },

    getCurrentUserSubscription() {
      SubscriptionService.getCurrentUserSubscription()
        .then((subscription) => {
          this.subscription = subscription;
        })
        .catch((err) => this.$log.error(err));
    },

    getCurrenUserData() {
      CurrentUserService.currentUserData()
        .then((userData) => (this.user = userData))
        .catch((err) => this.$log.error(err));
    },
  },
  watch: {
    percentage() {
      this.percentForm = this.percentage;
    },
    percentageimo() {
      this.percentForm1 = this.percentageimo;
    },
  },
  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
